Index: /Users/hdiwan/Developer/jython/src/org/python/core/PyDictionary.java
===================================================================
--- /Users/hdiwan/Developer/jython/src/org/python/core/PyDictionary.java	(revision 3610)
+++ /Users/hdiwan/Developer/jython/src/org/python/core/PyDictionary.java	(working copy)
@@ -1,8 +1,11 @@
 // Copyright (c) Corporation for National Research Initiatives
 package org.python.core;
 
+import java.util.HashSet;
 import java.util.Hashtable;
 import java.util.Enumeration;
+import java.util.Map;
+import java.util.Set;
 
 /**
  * A builtin python dictionary.
@@ -8,7 +11,8 @@
  * A builtin python dictionary.
  */
 
-public class PyDictionary extends PyObject {
+@SuppressWarnings("unchecked")
+public class PyDictionary extends PyObject implements java.util.Map {
 
     //~ BEGIN GENERATED REGION -- DO NOT EDIT SEE gexpose.py
     /* type info */
@@ -13,21 +17,25 @@
     //~ BEGIN GENERATED REGION -- DO NOT EDIT SEE gexpose.py
     /* type info */
 
-    public static final String exposed_name="dict";
+    /**
+	 * 
+	 */
+	private static final long serialVersionUID = 8676913666670782559L;
+	public static final String exposed_name="dict";
 
-    public static void typeSetup(PyObject dict,PyType.Newstyle marker) {
+    public static void typeSetup(final PyObject dict,final PyType.Newstyle marker) {
         class exposed___ne__ extends PyBuiltinMethodNarrow {
 
-            exposed___ne__(PyObject self,PyBuiltinFunction.Info info) {
+            exposed___ne__(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed___ne__(self,info);
             }
 
-            public PyObject __call__(PyObject arg0) {
-                PyObject ret=((PyDictionary)self).dict___ne__(arg0);
+            public PyObject __call__(final PyObject arg0) {
+                final PyObject ret=((PyDictionary)self).dict___ne__(arg0);
                 if (ret==null)
                     return Py.NotImplemented;
                 return ret;
@@ -37,16 +45,16 @@
         dict.__setitem__("__ne__",new PyMethodDescr("__ne__",PyDictionary.class,1,1,new exposed___ne__(null,null)));
         class exposed___eq__ extends PyBuiltinMethodNarrow {
 
-            exposed___eq__(PyObject self,PyBuiltinFunction.Info info) {
+            exposed___eq__(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed___eq__(self,info);
             }
 
-            public PyObject __call__(PyObject arg0) {
-                PyObject ret=((PyDictionary)self).dict___eq__(arg0);
+            public PyObject __call__(final PyObject arg0) {
+                final PyObject ret=((PyDictionary)self).dict___eq__(arg0);
                 if (ret==null)
                     return Py.NotImplemented;
                 return ret;
@@ -56,16 +64,16 @@
         dict.__setitem__("__eq__",new PyMethodDescr("__eq__",PyDictionary.class,1,1,new exposed___eq__(null,null)));
         class exposed___lt__ extends PyBuiltinMethodNarrow {
 
-            exposed___lt__(PyObject self,PyBuiltinFunction.Info info) {
+            exposed___lt__(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed___lt__(self,info);
             }
 
-            public PyObject __call__(PyObject arg0) {
-                PyObject ret=((PyDictionary)self).dict___lt__(arg0);
+            public PyObject __call__(final PyObject arg0) {
+                final PyObject ret=((PyDictionary)self).dict___lt__(arg0);
                 if (ret==null)
                     return Py.NotImplemented;
                 return ret;
@@ -75,16 +83,16 @@
         dict.__setitem__("__lt__",new PyMethodDescr("__lt__",PyDictionary.class,1,1,new exposed___lt__(null,null)));
         class exposed___gt__ extends PyBuiltinMethodNarrow {
 
-            exposed___gt__(PyObject self,PyBuiltinFunction.Info info) {
+            exposed___gt__(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed___gt__(self,info);
             }
 
-            public PyObject __call__(PyObject arg0) {
-                PyObject ret=((PyDictionary)self).dict___gt__(arg0);
+            public PyObject __call__(final PyObject arg0) {
+                final PyObject ret=((PyDictionary)self).dict___gt__(arg0);
                 if (ret==null)
                     return Py.NotImplemented;
                 return ret;
@@ -94,16 +102,16 @@
         dict.__setitem__("__gt__",new PyMethodDescr("__gt__",PyDictionary.class,1,1,new exposed___gt__(null,null)));
         class exposed___ge__ extends PyBuiltinMethodNarrow {
 
-            exposed___ge__(PyObject self,PyBuiltinFunction.Info info) {
+            exposed___ge__(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed___ge__(self,info);
             }
 
-            public PyObject __call__(PyObject arg0) {
-                PyObject ret=((PyDictionary)self).dict___ge__(arg0);
+            public PyObject __call__(final PyObject arg0) {
+                final PyObject ret=((PyDictionary)self).dict___ge__(arg0);
                 if (ret==null)
                     return Py.NotImplemented;
                 return ret;
@@ -113,16 +121,16 @@
         dict.__setitem__("__ge__",new PyMethodDescr("__ge__",PyDictionary.class,1,1,new exposed___ge__(null,null)));
         class exposed___le__ extends PyBuiltinMethodNarrow {
 
-            exposed___le__(PyObject self,PyBuiltinFunction.Info info) {
+            exposed___le__(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed___le__(self,info);
             }
 
-            public PyObject __call__(PyObject arg0) {
-                PyObject ret=((PyDictionary)self).dict___le__(arg0);
+            public PyObject __call__(final PyObject arg0) {
+                final PyObject ret=((PyDictionary)self).dict___le__(arg0);
                 if (ret==null)
                     return Py.NotImplemented;
                 return ret;
@@ -132,16 +140,16 @@
         dict.__setitem__("__le__",new PyMethodDescr("__le__",PyDictionary.class,1,1,new exposed___le__(null,null)));
         class exposed___cmp__ extends PyBuiltinMethodNarrow {
 
-            exposed___cmp__(PyObject self,PyBuiltinFunction.Info info) {
+            exposed___cmp__(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed___cmp__(self,info);
             }
 
-            public PyObject __call__(PyObject arg0) {
-                int ret=((PyDictionary)self).dict___cmp__(arg0);
+            public PyObject __call__(final PyObject arg0) {
+                final int ret=((PyDictionary)self).dict___cmp__(arg0);
                 if (ret==-2) {
                     throw Py.TypeError("dict"+".__cmp__(x,y) requires y to be '"+"dict"+"', not a '"+(arg0).getType().fastGetName()+"'");
                 }
@@ -152,16 +160,16 @@
         dict.__setitem__("__cmp__",new PyMethodDescr("__cmp__",PyDictionary.class,1,1,new exposed___cmp__(null,null)));
         class exposed___getitem__ extends PyBuiltinMethodNarrow {
 
-            exposed___getitem__(PyObject self,PyBuiltinFunction.Info info) {
+            exposed___getitem__(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed___getitem__(self,info);
             }
 
-            public PyObject __call__(PyObject arg0) {
-                PyObject ret=((PyDictionary)self).dict___finditem__(arg0);
+            public PyObject __call__(final PyObject arg0) {
+                final PyObject ret=((PyDictionary)self).dict___finditem__(arg0);
                 if (ret==null)
                     throw Py.KeyError(arg0.toString());
                 return ret;
@@ -171,19 +179,19 @@
         dict.__setitem__("__getitem__",new PyMethodDescr("__getitem__",PyDictionary.class,1,1,new exposed___getitem__(null,null)));
         class exposed_fromkeys extends PyBuiltinMethodNarrow {
 
-            exposed_fromkeys(PyObject self,PyBuiltinFunction.Info info) {
+            exposed_fromkeys(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed_fromkeys(self,info);
             }
 
-            public PyObject __call__(PyObject arg0,PyObject arg1) {
+            public PyObject __call__(final PyObject arg0,final PyObject arg1) {
                 return dict_fromkeys((PyType)getSelf(),arg0,arg1);
             }
 
-            public PyObject __call__(PyObject arg0) {
+            public PyObject __call__(final PyObject arg0) {
                 return dict_fromkeys((PyType)getSelf(),arg0);
             }
 
@@ -191,19 +199,19 @@
         dict.__setitem__("fromkeys",new PyClassMethodDescr("fromkeys",PyDictionary.class,1,2,new exposed_fromkeys(null,null)));
         class exposed_get extends PyBuiltinMethodNarrow {
 
-            exposed_get(PyObject self,PyBuiltinFunction.Info info) {
+            exposed_get(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed_get(self,info);
             }
 
-            public PyObject __call__(PyObject arg0,PyObject arg1) {
+            public PyObject __call__(final PyObject arg0,final PyObject arg1) {
                 return((PyDictionary)self).dict_get(arg0,arg1);
             }
 
-            public PyObject __call__(PyObject arg0) {
+            public PyObject __call__(final PyObject arg0) {
                 return((PyDictionary)self).dict_get(arg0);
             }
 
@@ -211,19 +219,19 @@
         dict.__setitem__("get",new PyMethodDescr("get",PyDictionary.class,1,2,new exposed_get(null,null)));
         class exposed_setdefault extends PyBuiltinMethodNarrow {
 
-            exposed_setdefault(PyObject self,PyBuiltinFunction.Info info) {
+            exposed_setdefault(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed_setdefault(self,info);
             }
 
-            public PyObject __call__(PyObject arg0,PyObject arg1) {
+            public PyObject __call__(final PyObject arg0,final PyObject arg1) {
                 return((PyDictionary)self).dict_setdefault(arg0,arg1);
             }
 
-            public PyObject __call__(PyObject arg0) {
+            public PyObject __call__(final PyObject arg0) {
                 return((PyDictionary)self).dict_setdefault(arg0);
             }
 
@@ -231,19 +239,19 @@
         dict.__setitem__("setdefault",new PyMethodDescr("setdefault",PyDictionary.class,1,2,new exposed_setdefault(null,null)));
         class exposed_pop extends PyBuiltinMethodNarrow {
 
-            exposed_pop(PyObject self,PyBuiltinFunction.Info info) {
+            exposed_pop(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed_pop(self,info);
             }
 
-            public PyObject __call__(PyObject arg0,PyObject arg1) {
+            public PyObject __call__(final PyObject arg0,final PyObject arg1) {
                 return((PyDictionary)self).dict_pop(arg0,arg1);
             }
 
-            public PyObject __call__(PyObject arg0) {
+            public PyObject __call__(final PyObject arg0) {
                 return((PyDictionary)self).dict_pop(arg0);
             }
 
@@ -251,11 +259,11 @@
         dict.__setitem__("pop",new PyMethodDescr("pop",PyDictionary.class,1,2,new exposed_pop(null,null)));
         class exposed_popitem extends PyBuiltinMethodNarrow {
 
-            exposed_popitem(PyObject self,PyBuiltinFunction.Info info) {
+            exposed_popitem(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed_popitem(self,info);
             }
 
@@ -267,15 +275,15 @@
         dict.__setitem__("popitem",new PyMethodDescr("popitem",PyDictionary.class,0,0,new exposed_popitem(null,null)));
         class exposed_has_key extends PyBuiltinMethodNarrow {
 
-            exposed_has_key(PyObject self,PyBuiltinFunction.Info info) {
+            exposed_has_key(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed_has_key(self,info);
             }
 
-            public PyObject __call__(PyObject arg0) {
+            public PyObject __call__(final PyObject arg0) {
                 return Py.newBoolean(((PyDictionary)self).dict_has_key(arg0));
             }
 
@@ -283,15 +291,15 @@
         dict.__setitem__("has_key",new PyMethodDescr("has_key",PyDictionary.class,1,1,new exposed_has_key(null,null)));
         class exposed___contains__ extends PyBuiltinMethodNarrow {
 
-            exposed___contains__(PyObject self,PyBuiltinFunction.Info info) {
+            exposed___contains__(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed___contains__(self,info);
             }
 
-            public PyObject __call__(PyObject arg0) {
+            public PyObject __call__(final PyObject arg0) {
                 return Py.newBoolean(((PyDictionary)self).dict___contains__(arg0));
             }
 
@@ -299,11 +307,11 @@
         dict.__setitem__("__contains__",new PyMethodDescr("__contains__",PyDictionary.class,1,1,new exposed___contains__(null,null)));
         class exposed___len__ extends PyBuiltinMethodNarrow {
 
-            exposed___len__(PyObject self,PyBuiltinFunction.Info info) {
+            exposed___len__(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed___len__(self,info);
             }
 
@@ -315,15 +323,15 @@
         dict.__setitem__("__len__",new PyMethodDescr("__len__",PyDictionary.class,0,0,new exposed___len__(null,null)));
         class exposed___setitem__ extends PyBuiltinMethodNarrow {
 
-            exposed___setitem__(PyObject self,PyBuiltinFunction.Info info) {
+            exposed___setitem__(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed___setitem__(self,info);
             }
 
-            public PyObject __call__(PyObject arg0,PyObject arg1) {
+            public PyObject __call__(final PyObject arg0,final PyObject arg1) {
                 ((PyDictionary)self).dict___setitem__(arg0,arg1);
                 return Py.None;
             }
@@ -332,15 +340,15 @@
         dict.__setitem__("__setitem__",new PyMethodDescr("__setitem__",PyDictionary.class,2,2,new exposed___setitem__(null,null)));
         class exposed___delitem__ extends PyBuiltinMethodNarrow {
 
-            exposed___delitem__(PyObject self,PyBuiltinFunction.Info info) {
+            exposed___delitem__(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed___delitem__(self,info);
             }
 
-            public PyObject __call__(PyObject arg0) {
+            public PyObject __call__(final PyObject arg0) {
                 ((PyDictionary)self).dict___delitem__(arg0);
                 return Py.None;
             }
@@ -349,11 +357,11 @@
         dict.__setitem__("__delitem__",new PyMethodDescr("__delitem__",PyDictionary.class,1,1,new exposed___delitem__(null,null)));
         class exposed_keys extends PyBuiltinMethodNarrow {
 
-            exposed_keys(PyObject self,PyBuiltinFunction.Info info) {
+            exposed_keys(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed_keys(self,info);
             }
 
@@ -365,15 +373,15 @@
         dict.__setitem__("keys",new PyMethodDescr("keys",PyDictionary.class,0,0,new exposed_keys(null,null)));
         class exposed_update extends PyBuiltinMethodNarrow {
 
-            exposed_update(PyObject self,PyBuiltinFunction.Info info) {
+            exposed_update(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed_update(self,info);
             }
 
-            public PyObject __call__(PyObject arg0) {
+            public PyObject __call__(final PyObject arg0) {
                 ((PyDictionary)self).dict_update(arg0);
                 return Py.None;
             }
@@ -382,11 +390,11 @@
         dict.__setitem__("update",new PyMethodDescr("update",PyDictionary.class,1,1,new exposed_update(null,null)));
         class exposed_itervalues extends PyBuiltinMethodNarrow {
 
-            exposed_itervalues(PyObject self,PyBuiltinFunction.Info info) {
+            exposed_itervalues(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed_itervalues(self,info);
             }
 
@@ -398,11 +406,11 @@
         dict.__setitem__("itervalues",new PyMethodDescr("itervalues",PyDictionary.class,0,0,new exposed_itervalues(null,null)));
         class exposed_iteritems extends PyBuiltinMethodNarrow {
 
-            exposed_iteritems(PyObject self,PyBuiltinFunction.Info info) {
+            exposed_iteritems(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed_iteritems(self,info);
             }
 
@@ -414,11 +422,11 @@
         dict.__setitem__("iteritems",new PyMethodDescr("iteritems",PyDictionary.class,0,0,new exposed_iteritems(null,null)));
         class exposed_iterkeys extends PyBuiltinMethodNarrow {
 
-            exposed_iterkeys(PyObject self,PyBuiltinFunction.Info info) {
+            exposed_iterkeys(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed_iterkeys(self,info);
             }
 
@@ -430,11 +438,11 @@
         dict.__setitem__("iterkeys",new PyMethodDescr("iterkeys",PyDictionary.class,0,0,new exposed_iterkeys(null,null)));
         class exposed_items extends PyBuiltinMethodNarrow {
 
-            exposed_items(PyObject self,PyBuiltinFunction.Info info) {
+            exposed_items(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed_items(self,info);
             }
 
@@ -446,11 +454,11 @@
         dict.__setitem__("items",new PyMethodDescr("items",PyDictionary.class,0,0,new exposed_items(null,null)));
         class exposed_values extends PyBuiltinMethodNarrow {
 
-            exposed_values(PyObject self,PyBuiltinFunction.Info info) {
+            exposed_values(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed_values(self,info);
             }
 
@@ -462,11 +470,11 @@
         dict.__setitem__("values",new PyMethodDescr("values",PyDictionary.class,0,0,new exposed_values(null,null)));
         class exposed_clear extends PyBuiltinMethodNarrow {
 
-            exposed_clear(PyObject self,PyBuiltinFunction.Info info) {
+            exposed_clear(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed_clear(self,info);
             }
 
@@ -479,11 +487,11 @@
         dict.__setitem__("clear",new PyMethodDescr("clear",PyDictionary.class,0,0,new exposed_clear(null,null)));
         class exposed_copy extends PyBuiltinMethodNarrow {
 
-            exposed_copy(PyObject self,PyBuiltinFunction.Info info) {
+            exposed_copy(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed_copy(self,info);
             }
 
@@ -495,11 +503,11 @@
         dict.__setitem__("copy",new PyMethodDescr("copy",PyDictionary.class,0,0,new exposed_copy(null,null)));
         class exposed___iter__ extends PyBuiltinMethodNarrow {
 
-            exposed___iter__(PyObject self,PyBuiltinFunction.Info info) {
+            exposed___iter__(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed___iter__(self,info);
             }
 
@@ -511,11 +519,11 @@
         dict.__setitem__("__iter__",new PyMethodDescr("__iter__",PyDictionary.class,0,0,new exposed___iter__(null,null)));
         class exposed___hash__ extends PyBuiltinMethodNarrow {
 
-            exposed___hash__(PyObject self,PyBuiltinFunction.Info info) {
+            exposed___hash__(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed___hash__(self,info);
             }
 
@@ -527,11 +535,11 @@
         dict.__setitem__("__hash__",new PyMethodDescr("__hash__",PyDictionary.class,0,0,new exposed___hash__(null,null)));
         class exposed___repr__ extends PyBuiltinMethodNarrow {
 
-            exposed___repr__(PyObject self,PyBuiltinFunction.Info info) {
+            exposed___repr__(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed___repr__(self,info);
             }
 
@@ -543,19 +551,19 @@
         dict.__setitem__("__repr__",new PyMethodDescr("__repr__",PyDictionary.class,0,0,new exposed___repr__(null,null)));
         class exposed___init__ extends PyBuiltinMethod {
 
-            exposed___init__(PyObject self,PyBuiltinFunction.Info info) {
+            exposed___init__(final PyObject self,final PyBuiltinFunction.Info info) {
                 super(self,info);
             }
 
-            public PyBuiltinFunction bind(PyObject self) {
+            public PyBuiltinFunction bind(final PyObject self) {
                 return new exposed___init__(self,info);
             }
 
-            public PyObject __call__(PyObject[]args) {
+            public PyObject __call__(final PyObject[]args) {
                 return __call__(args,Py.NoKeywords);
             }
 
-            public PyObject __call__(PyObject[]args,String[]keywords) {
+            public PyObject __call__(final PyObject[]args,final String[]keywords) {
                 ((PyDictionary)self).dict_init(args,keywords);
                 return Py.None;
             }
@@ -564,7 +572,7 @@
         dict.__setitem__("__init__",new PyMethodDescr("__init__",PyDictionary.class,-1,-1,new exposed___init__(null,null)));
         dict.__setitem__("__new__",new PyNewWrapper(PyDictionary.class,"__new__",-1,-1) {
 
-                                                                                            public PyObject new_impl(boolean init,PyType subtype,PyObject[]args,String[]keywords) {
+                                                                                            public PyObject new_impl(final boolean init,final PyType subtype,final PyObject[]args,final String[]keywords) {
                                                                                                 PyDictionary newobj;
                                                                                                 if (for_type==subtype) {
                                                                                                     newobj=new PyDictionary();
@@ -593,7 +601,7 @@
      * For derived types
      * @param subtype
      */
-    public PyDictionary(PyType subtype) {
+    public PyDictionary(final PyType subtype) {
         super(subtype);
         table = new Hashtable();
     }
@@ -603,7 +611,7 @@
      * @param t  the hashtable used. The supplied hashtable is used as
      *           is and must only contain PyObject key:value pairs.
      */
-    public PyDictionary(Hashtable t) {
+    public PyDictionary(final Hashtable t) {
         table = t;
     }
 
@@ -613,7 +621,7 @@
      *                 dictionary. Even numbered elements are keys,
      *                 odd numbered elements are values.
      */
-    public PyDictionary(PyObject elements[]) {
+    public PyDictionary(final PyObject elements[]) {
         this();
         for (int i = 0; i < elements.length; i+=2) {
             table.put(elements[i], elements[i+1]);
@@ -620,8 +628,8 @@
         }
     }
 
-    final void dict_init(PyObject[] args,String[] kwds) {
-        int nargs = args.length - kwds.length;
+    final void dict_init(final PyObject[] args,final String[] kwds) {
+        final int nargs = args.length - kwds.length;
         if (nargs > 1)
             throw PyBuiltinFunction.DefaultInfo.unexpectedCall(
                     nargs,
@@ -630,11 +638,11 @@
                     0,
                     1);
         if (nargs == 1) {
-            PyObject src = args[0];
+            final PyObject src = args[0];
             if (src.__findattr__("keys") != null)
                 this.update(src);
             else {
-                PyObject pairs = Py.iter(src, "iteration over non-sequence");
+                final PyObject pairs = Py.iter(src, "iteration over non-sequence");
                 PyObject pair;
                 int cnt = 0;
                 for (; (pair = pairs.__iternext__()) != null; cnt++) {
@@ -640,7 +648,7 @@
                 for (; (pair = pairs.__iternext__()) != null; cnt++) {
                     try {
                         pair = PySequence.fastSequence(pair, "");
-                    } catch(PyException e) {
+                    } catch(final PyException e) {
                         if (Py.matchException(e, Py.TypeError))
                             throw Py.TypeError("cannot convert dictionary update "+
                                     "sequence element #"+cnt+" to a sequence");
@@ -659,24 +667,24 @@
             this.__setitem__(kwds[i],args[nargs+i]);
         }        
     }
-    public static PyObject fromkeys(PyObject keys) {
+    public static PyObject fromkeys(final PyObject keys) {
         return fromkeys(keys, null);
     }
 
-    public static PyObject fromkeys(PyObject keys, PyObject value) {
+    public static PyObject fromkeys(final PyObject keys, final PyObject value) {
         return dict_fromkeys(PyType.fromClass(PyDictionary.class), keys, value);
     }
 
-    final static PyObject dict_fromkeys(PyType type, PyObject keys) {
+    final static PyObject dict_fromkeys(final PyType type, final PyObject keys) {
         return dict_fromkeys(type, keys, null);
     }
 
-    final static PyObject dict_fromkeys(PyType type, PyObject keys, PyObject value) {
+    final static PyObject dict_fromkeys(final PyType type, final PyObject keys, PyObject value) {
         if (value == null) {
             value = Py.None;
         }
-        PyObject d = type.__call__();
-        PyIterator iter = (PyIterator)keys.__iter__();
+        final PyObject d = type.__call__();
+        final PyIterator iter = (PyIterator)keys.__iter__();
         for (PyObject o = iter.__iternext__();o != null;o = iter.__iternext__()) {
             d.__setitem__(o, value);
         }
@@ -709,32 +717,32 @@
         return table.size() != 0;
     }
 
-    public PyObject __finditem__(int index) {
+    public PyObject __finditem__(final int index) {
         throw Py.TypeError("loop over non-sequence");
     }
 
-    public PyObject __finditem__(PyObject key) {
+    public PyObject __finditem__(final PyObject key) {
         return dict___finditem__(key);
     }
 
-    final PyObject dict___finditem__(PyObject key) {
+    final PyObject dict___finditem__(final PyObject key) {
         return (PyObject)table.get(key);
     }
 
-    public void __setitem__(PyObject key, PyObject value) {
+    public void __setitem__(final PyObject key, final PyObject value) {
         dict___setitem__(key,value);
     }
 
-    final void dict___setitem__(PyObject key, PyObject value)  {
+    final void dict___setitem__(final PyObject key, final PyObject value)  {
         table.put(key, value);
     }
 
-    public void __delitem__(PyObject key) {
+    public void __delitem__(final PyObject key) {
         dict___delitem__(key);
     }
 
-    final void dict___delitem__(PyObject key) {
-        Object ret = table.remove(key);
+    final void dict___delitem__(final PyObject key) {
+        final Object ret = table.remove(key);
         if (ret == null)
             throw Py.KeyError(key.toString());
     }
@@ -752,7 +760,7 @@
     }
 
     final String dict_toString() {
-        ThreadState ts = Py.getThreadState();
+        final ThreadState ts = Py.getThreadState();
         if (!ts.enterRepr(this)) {
             return "{...}";
         }
@@ -757,9 +765,9 @@
             return "{...}";
         }
 
-        java.util.Enumeration ek = table.keys();
-        java.util.Enumeration ev = table.elements();
-        StringBuffer buf = new StringBuffer("{");
+        final java.util.Enumeration ek = table.keys();
+        final java.util.Enumeration ev = table.elements();
+        final StringBuffer buf = new StringBuffer("{");
         while(ek.hasMoreElements() && ev.hasMoreElements()) {
             buf.append(((PyObject)ek.nextElement()).__repr__().toString());
             buf.append(": ");
@@ -775,27 +783,27 @@
         return buf.toString();
     }
 
-    public PyObject __eq__(PyObject ob_other) {
+    public PyObject __eq__(final PyObject ob_other) {
         return dict___eq__(ob_other);
     }
 
-    final PyObject dict___eq__(PyObject ob_other) {
+    final PyObject dict___eq__(final PyObject ob_other) {
         if (ob_other.getType() != getType())
             return null;
 
-        PyDictionary other = (PyDictionary)ob_other;
-        int an = table.size();
-        int bn = other.table.size();
+        final PyDictionary other = (PyDictionary)ob_other;
+        final int an = table.size();
+        final int bn = other.table.size();
         if (an != bn)
             return Py.Zero;
 
-        PyList akeys = keys();
+        final PyList akeys = keys();
         for (int i=0; i<an; i++) {
-            PyObject akey = akeys.pyget(i);
-            PyObject bvalue = other.__finditem__(akey);
+            final PyObject akey = akeys.pyget(i);
+            final PyObject bvalue = other.__finditem__(akey);
             if (bvalue == null)
                 return Py.Zero;
-            PyObject avalue = __finditem__(akey);
+            final PyObject avalue = __finditem__(akey);
             if (!avalue._eq(bvalue).__nonzero__())
                 return Py.Zero;
         }
@@ -802,12 +810,12 @@
         return Py.One;
     }
 
-    public PyObject __ne__(PyObject ob_other) {
+    public PyObject __ne__(final PyObject ob_other) {
         return dict___ne__(ob_other);
     }
 
-    final PyObject dict___ne__(PyObject ob_other) {
-        PyObject eq_result = __eq__(ob_other);
+    final PyObject dict___ne__(final PyObject ob_other) {
+        final PyObject eq_result = __eq__(ob_other);
         if (eq_result == null) return null;
         return  eq_result == Py.One?Py.Zero:Py.One;
     }
@@ -812,8 +820,8 @@
         return  eq_result == Py.One?Py.Zero:Py.One;
     }
     
-    final PyObject dict___lt__(PyObject ob_other){
-    	int result = __cmp__(ob_other);
+    final PyObject dict___lt__(final PyObject ob_other){
+    	final int result = __cmp__(ob_other);
     	if(result == -2){
     		return null;
     	}
@@ -820,8 +828,8 @@
     	return result < 0 ? Py.One : Py.Zero;
     }
     
-    final PyObject dict___gt__(PyObject ob_other){
-    	int result = __cmp__(ob_other);
+    final PyObject dict___gt__(final PyObject ob_other){
+    	final int result = __cmp__(ob_other);
     	if(result == -2){
     		return null;
     	}
@@ -828,8 +836,8 @@
     	return result > 0 ? Py.One : Py.Zero;
     }
     
-    final PyObject dict___le__(PyObject ob_other){
-    	int result = __cmp__(ob_other);
+    final PyObject dict___le__(final PyObject ob_other){
+    	final int result = __cmp__(ob_other);
     	if(result == -2){
     		return null;
     	}
@@ -836,8 +844,8 @@
     	return result <= 0 ? Py.One : Py.Zero;
     }
     
-    final PyObject dict___ge__(PyObject ob_other){
-    	int result = __cmp__(ob_other);
+    final PyObject dict___ge__(final PyObject ob_other){
+    	final int result = __cmp__(ob_other);
     	if(result == -2){
     		return null;
     	}
@@ -844,22 +852,22 @@
     	return result >= 0 ? Py.One : Py.Zero;
     }
 
-    public int __cmp__(PyObject ob_other) {
+    public int __cmp__(final PyObject ob_other) {
         return dict___cmp__(ob_other);
     }
 
-    final int dict___cmp__(PyObject ob_other) {
+    final int dict___cmp__(final PyObject ob_other) {
         if (ob_other.getType() != getType())
             return -2;
 
-        PyDictionary other = (PyDictionary)ob_other;
-        int an = table.size();
-        int bn = other.table.size();
+        final PyDictionary other = (PyDictionary)ob_other;
+        final int an = table.size();
+        final int bn = other.table.size();
         if (an < bn) return -1;
         if (an > bn) return 1;
 
-        PyList akeys = keys();
-        PyList bkeys = other.keys();
+        final PyList akeys = keys();
+        final PyList bkeys = other.keys();
 
         akeys.sort();
         bkeys.sort();
@@ -865,8 +873,8 @@
         bkeys.sort();
 
         for (int i=0; i<bn; i++) {
-            PyObject akey = akeys.pyget(i);
-            PyObject bkey = bkeys.pyget(i);
+            final PyObject akey = akeys.pyget(i);
+            final PyObject bkey = bkeys.pyget(i);
             int c = akey._cmp(bkey);
             if (c != 0)
                 return c;
@@ -871,8 +879,8 @@
             if (c != 0)
                 return c;
 
-            PyObject avalue = __finditem__(akey);
-            PyObject bvalue = other.__finditem__(bkey);
+            final PyObject avalue = __finditem__(akey);
+            final PyObject bvalue = other.__finditem__(bkey);
             if(avalue == null){
                 if(bvalue == null){
                     continue;
@@ -891,19 +899,19 @@
     /**
      * Return true if the key exist in the dictionary.
      */
-    public boolean has_key(PyObject key) {
+    public boolean has_key(final PyObject key) {
         return dict_has_key(key);
     }
 
-    final boolean dict_has_key(PyObject key) {
+    final boolean dict_has_key(final PyObject key) {
         return table.containsKey(key);
     }
 
-    public boolean __contains__(PyObject o) {
+    public boolean __contains__(final PyObject o) {
         return dict___contains__(o);
     }
 
-    final boolean dict___contains__(PyObject o) {
+    final boolean dict___contains__(final PyObject o) {
         return dict_has_key(o);
     }
 
@@ -915,12 +923,12 @@
      * @param default_object the value to return if the key does not
      *                       exists in the mapping.
      */
-    public PyObject get(PyObject key, PyObject default_object) {
+    public PyObject get(final PyObject key, final PyObject default_object) {
         return dict_get(key,default_object);
     }
 
-    final PyObject dict_get(PyObject key, PyObject default_object) {
-        PyObject o = dict___finditem__(key);
+    final PyObject dict_get(final PyObject key, final PyObject default_object) {
+        final PyObject o = dict___finditem__(key);
         if (o == null)
             return default_object;
         else
@@ -933,11 +941,11 @@
      *
      * @param key  the key to lookup in the dictionary.
      */
-    public PyObject get(PyObject key) {
+    public PyObject get(final PyObject key) {
         return dict_get(key);
     }
 
-    final PyObject dict_get(PyObject key) {
+    final PyObject dict_get(final PyObject key) {
         return get(key, Py.None);
     }
 
@@ -967,11 +975,11 @@
      * Insert all the key:value pairs from <code>d</code> into
      * this dictionary.
      */
-    public void update(PyObject d) {
+    public void update(final PyObject d) {
         dict_update(d);
     }
 
-    final void dict_update(PyObject d) {
+    final void dict_update(final PyObject d) {
         if (d instanceof PyDictionary) {
             do_update((PyDictionary)d);
         } else if (d instanceof PyStringMap) {
@@ -982,12 +990,12 @@
 
     }
 
-    private void do_update(PyDictionary d) {
-        Hashtable otable = d.table;
+    private void do_update(final PyDictionary d) {
+        final Hashtable otable = d.table;
 
-        java.util.Enumeration ek = otable.keys();
-        java.util.Enumeration ev = otable.elements();
-        int n = otable.size();
+        final java.util.Enumeration ek = otable.keys();
+        final java.util.Enumeration ev = otable.elements();
+        final int n = otable.size();
 
         for (int i=0; i<n; i++)
             table.put(ek.nextElement(), ev.nextElement());
@@ -993,8 +1001,8 @@
             table.put(ek.nextElement(), ev.nextElement());
     }
 
-    private void do_update(PyObject d,PyObject keys) {
-        PyObject iter = keys.__iter__();
+    private void do_update(final PyObject d,final PyObject keys) {
+        final PyObject iter = keys.__iter__();
         for (PyObject key; (key = iter.__iternext__()) != null; )
             __setitem__(key, d.__getitem__(key));
     }
@@ -1005,11 +1013,11 @@
      *
      * @param key   the key to lookup in the dictionary.
      */
-    public PyObject setdefault(PyObject key) {
+    public PyObject setdefault(final PyObject key) {
         return dict_setdefault(key);
     }
 
-    final PyObject dict_setdefault(PyObject key) {
+    final PyObject dict_setdefault(final PyObject key) {
         return setdefault(key, Py.None);
     }
 
@@ -1021,11 +1029,11 @@
      * @param failobj the default value to insert in the dictionary
      *                if key does not already exist.
      */
-    public PyObject setdefault(PyObject key, PyObject failobj) {
+    public PyObject setdefault(final PyObject key, final PyObject failobj) {
         return dict_setdefault(key,failobj);
     }
 
-    final PyObject dict_setdefault(PyObject key, PyObject failobj) {
+    final PyObject dict_setdefault(final PyObject key, final PyObject failobj) {
         PyObject o = __finditem__(key);
         if (o == null)
             __setitem__(key, o = failobj);
@@ -1036,14 +1044,14 @@
      * Return a value based on key
      * from the dictionary.
      */
-    public PyObject pop(PyObject key) {
+    public PyObject pop(final PyObject key) {
         return dict_pop(key);
     }
 
-    final PyObject dict_pop(PyObject key) {
+    final PyObject dict_pop(final PyObject key) {
         if (!table.containsKey(key))
             throw Py.KeyError("popitem(): dictionary is empty");
-        PyObject val = (PyObject) table.get(key);
+        final PyObject val = (PyObject) table.get(key);
         table.remove(key);
         return val;
     }
@@ -1052,14 +1060,14 @@
      * Return a value based on key
      * from the dictionary or default if that key is not found.
      */
-    public PyObject pop(PyObject key, PyObject defaultValue) {
+    public PyObject pop(final PyObject key, final PyObject defaultValue) {
         return dict_pop(key, defaultValue);
     }
 
-    final PyObject dict_pop(PyObject key, PyObject defaultValue) {
+    final PyObject dict_pop(final PyObject key, final PyObject defaultValue) {
         if (!table.containsKey(key))
             return defaultValue;
-        PyObject val = (PyObject) table.get(key);
+        final PyObject val = (PyObject) table.get(key);
         table.remove(key);
         return val;
     }
@@ -1074,11 +1082,11 @@
     }
 
     final PyObject dict_popitem() {
-        java.util.Enumeration keys = table.keys();
+        final java.util.Enumeration keys = table.keys();
         if (!keys.hasMoreElements())
             throw Py.KeyError("popitem(): dictionary is empty");
-        PyObject key = (PyObject) keys.nextElement();
-        PyObject val = (PyObject) table.get(key);
+        final PyObject key = (PyObject) keys.nextElement();
+        final PyObject val = (PyObject) table.get(key);
         table.remove(key);
         return new PyTuple(new PyObject[] { key, val });
     }
@@ -1092,10 +1100,10 @@
     }
 
     final PyList dict_items() {
-        java.util.Enumeration ek = table.keys();
-        java.util.Enumeration ev = table.elements();
-        int n = table.size();
-        PyObject[] elements = new PyObject[n];
+        final java.util.Enumeration ek = table.keys();
+        final java.util.Enumeration ev = table.elements();
+        final int n = table.size();
+        final PyObject[] elements = new PyObject[n];
         for (int i=0; i<n; i++) {
             elements[i] = new PyTuple(new PyObject[] {
                 (PyObject)ek.nextElement(), (PyObject)ev.nextElement()
@@ -1112,9 +1120,9 @@
     }
 
     final PyList dict_keys() {
-        java.util.Enumeration e = table.keys();
-        int n = table.size();
-        PyObject[] elements = new PyObject[n];
+        final java.util.Enumeration e = table.keys();
+        final int n = table.size();
+        final PyObject[] elements = new PyObject[n];
 
         for (int i=0; i<n; i++) {
             elements[i] = (PyObject)e.nextElement();
@@ -1130,9 +1138,9 @@
     }
 
     final PyList dict_values() {
-        java.util.Enumeration e = table.elements();
-        int n = table.size();
-        PyObject[] elements = new PyObject[n];
+        final java.util.Enumeration e = table.elements();
+        final int n = table.size();
+        final PyObject[] elements = new PyObject[n];
         for (int i=0; i<n; i++) {
             elements[i] = (PyObject)e.nextElement();
         }
@@ -1187,7 +1195,51 @@
         return false;
     }
 
+	public boolean containsKey(final Object arg0) {
+		return this.dict_has_key((PyObject) arg0);
+	}
+
+	public boolean containsValue(final Object arg0) {
+		return this.dict___contains__((PyObject)arg0);
+	}
+
+	public Set entrySet() {
+		return new HashSet(this.values());
+	}
+
+	public Object get(final Object arg0) {
+		return (Object)this.dict_get((PyObject)arg0);
+	}
+
+	public boolean isEmpty() {
+		return this.dict___nonzero__() == false;
+	}
+
+	public Set keySet() {
+		return null;
+	}
 
+	public Object put(final Object arg0, final Object arg1) {
+		this.dict___setitem__((PyObject)arg0, (PyObject)arg1);
+		return null;
+	}
+
+	public void putAll(final Map arg0) {
+		
+	}
+
+	public Object remove(final Object arg0) {
+		this.dict___setitem__((PyObject)arg0, null);
+		return arg0;
+	}
+
+	public int size() {
+		return this.dict___len__();
+	}
+
+	public boolean equals(Object o) {
+		return (boolean)this.equals((PyObject)o);
+	}
 }
 
 class PyDictionaryIter extends PyIterator {

 	  	 
